<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Using dwmblocks With dwm's Bar</title>
<meta name="author" content="dt" />
<meta name="description" content="Guest Articles - Using dwmblocks With dwm's Bar
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">Using dwmblocks With dwm&rsquo;s Bar</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#org8d72a27">Using dwmblocks With dwm&rsquo;s Bar</a></li>
<li><a href="#orgdeef2e7">Introduction</a></li>
<li><a href="#org5985bf8">Installation</a></li>
<li><a href="#org16566ca">Making The Script</a></li>
<li><a href="#orgc84e6b0">Configuration</a></li>
<li><a href="#org367202b">Backup</a></li>
<li><a href="#orgdea7fd1">Links</a></li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="../kb/index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-org8d72a27" class="outline-2">
<h2 id="org8d72a27">Using dwmblocks With dwm&rsquo;s Bar</h2>
<div class="outline-text-2" id="text-org8d72a27">
<p>
<i>By Ronnie Nissan at April 20, 2020</i>
</p>
</div>
</div>

<div id="outline-container-orgdeef2e7" class="outline-2">
<h2 id="orgdeef2e7">Introduction</h2>
<div class="outline-text-2" id="text-orgdeef2e7">
<p>
Dwmblocks is one of the many status bars available at suckless.org&rsquo;s status monitor page (link at end of article), but I see it as the best one available, as it is easy to configure and it uses a blocks concept just like i3blocks, so you can write simple commands that print something (like volume) to the stdout and feed it into dwmblocks, give it an update interval, a signal, and it will print it to the WM_NAME which is the name of the root window of x11 and is managed by dwm. Here I will show you how to install, configure and run it. I&rsquo;ll also show you howto write a simple script to print your the date to the status bar with an icon next to it
</p>
</div>
</div>

<div id="outline-container-org5985bf8" class="outline-2">
<h2 id="org5985bf8">Installation</h2>
<div class="outline-text-2" id="text-org5985bf8">
<p>
To install dwmblocks, you&rsquo;ll first have to clone the repository from GitHub
</p>

<pre class="example" id="org0e99354">
https://github.com/torrinfail/dwmblocks.git #then cd into the dwmblocks
cd dwmblocks
</pre>

<p>
Then you install it the same way you install any other suckless tool, by compiling the source code and then installing it, using the following commands:
</p>

<pre class="example" id="orgd387470">
make
sudo make install
</pre>

<p>
This will install dwmblocks to your system but you still can&rsquo;t use it as it is.
</p>
</div>
</div>

<div id="outline-container-org16566ca" class="outline-2">
<h2 id="org16566ca">Making The Script</h2>
<div class="outline-text-2" id="text-org16566ca">
<p>
We will make a simple script that will print the date to the status bar. In the following example we use the date command and printf to print a formatted string and show it in dwm&rsquo;s bar.
</p>

<pre class="example" id="org2465d6f">
#!/bin/sh
date=$(date '+%b %d (%a) %H:%M')
icon='icon'
printf " %s %s \\n" "$icon" "$date"
</pre>

<p>
In the above script we made a variable called date, which runs the shell command of date with the specific formatting, you can change the formatting by reading the man page for date. On the third line we set another optional variable called icon, which sets a simple icon, it can be an emoji, or an icon from font awesome for example. On line 4 of the script we call the printf function which prints out a formatted string to the stdout, and here it will print the icon of your choice, then the date as the format you specified in line 2. And the results of the above will be:
</p>

<pre class="example" id="org6eed85d">
icon Apr 14 (Tue) 02:41
</pre>
</div>
</div>

<div id="outline-container-orgc84e6b0" class="outline-2">
<h2 id="orgc84e6b0">Configuration</h2>
<div class="outline-text-2" id="text-orgc84e6b0">
<p>
Now that you have working script that gives you the current time, you should save it to a file called “time.sh” for example and put it in your path, along with any other script you want to use with dwmblocks. then we go back to the dwmblocks directory and we edit the blocks.h file.
</p>

<pre class="example" id="org7d826ae">
static const Block blocks[] = {
	/*Icon*/	/*Command*/		/*Update Interval*/	/*Update Signal*/
	{"",         "time.sh",	     60,                     0},
	{"",         "brightness.sh",	 0,                      11},
};
</pre>

<p>
Above we add our script “time.sh” under command, set the update interval to 60 seconds and the update signal to 0, we leave the icon option empty as we already added an icon though out script. We assume we have another script called brightness.sh which prints the brightness to the status bar, but we want it to update only when we make a change to the screen brightness and that&rsquo;s why we have the update interval to 0 and the update signal to 11. After you finish adding your scripts (blocks) to the config.h, you must recompile and install dwmblocks again.
</p>

<p>
So now if we run pkill -RTMIN+11 dwmblocks from a terminal, the brightness block will be updated, so you should assign a different signal to each command that you want to update only when a change happens (volume for example) and call the above command every time you change brightness or volume, change the -RTMIN+11 to the signal you put in your blocks.h for that specific command.
</p>

<p>
For example, I use sxhkd to set a hotkey that uses “light” to change the brightness. so I have the following in my sxhkdrc
</p>

<pre class="example" id="orgf6689ef">
super + Up
    light -A 5 &amp;&amp; pkill -RTMIN+11 dwmblocks
super + Down
    light -U 5 &amp;&amp; pkill -RTMIN+11 dwmblocks
</pre>

<p>
There might be better ways to do this, but this is the one I use.
</p>

<p>
After you finish setting up dwmblocks the way you want with your blocks, you should autostart dwmblocks though .xinitrc or add it to your autostart file if you are using the autostart patch for dwm (link at end of article).
</p>
</div>
</div>

<div id="outline-container-org367202b" class="outline-2">
<h2 id="org367202b">Backup</h2>
<div class="outline-text-2" id="text-org367202b">
<p>
First of all you have to be in the directory of the program you want to make a backup of. then you&rsquo;ll rename the remote of the git repository from origin to upstream.
</p>

<pre class="example" id="org3438845">
git remote rename origin upstream
</pre>

<p>
Then you&rsquo;ll go to GitHub.com (or Gitlab) and make a new repository, call it the same as the program you are backing up for convenience. then copy the repository&rsquo;s URL and type:
</p>

<pre class="example" id="org9aa6d86">
git add remote origin &lt;the repository's url&gt;
</pre>

<p>
Now if you type:
</p>

<pre class="example" id="orgf381b13">
git remote -v
</pre>

<p>
You&rsquo;ll see that you have two remotes called upstream (pointing to suckless.org) and one called origin (pointing to your repository). now all that&rsquo;s left is that you push your build to the master branch of your repository, to do that you type:
</p>

<pre class="example" id="org24dd067">
git push origin master
</pre>

<p>
If the dwmblocks developer updated the program, all you&rsquo;ll have to do is, go to that programs directory, and run the following:
</p>

<pre class="example" id="org10566e0">
git pull upstream master
</pre>

<p>
For more scripts, check my dotfiles (link below) repository on my Github page and check the “statusbar” directory inside my Script directory.
</p>
</div>
</div>

<div id="outline-container-orgdea7fd1" class="outline-2">
<h2 id="orgdea7fd1">Links</h2>
<div class="outline-text-2" id="text-orgdea7fd1">
<ul class="org-ul">
<li><a href="https://dwm.suckless.org/status_monitor/">Dwm Status Monitor</a></li>
<li><a href="https://dwm.suckless.org/patches/autostart/">Dwm Autostart Patch</a></li>
<li><a href="https://github.com/ronniedroid/.dotfiles">My Dotfiles</a></li>
</ul>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
